searchNodes=[{"doc":"InfluxDB driver for ElixirConnectionsTo connect to an InfluxDB server you need a connection module:defmodule MyApp.MyConnection do use Instream.Connection, otp_app: :my_app endThe :otp_app name and the name of the module can be freely chosen but have to be linked to a corresponding configuration entry. This defined connection module needs to be hooked up into your supervision tree:children = [ # ... MyApp.Connection, # ... ]Example of the matching configuration entry:config :my_app, MyApp.MyConnection, database: &quot;my_default_database&quot;, host: &quot;localhost&quot;, port: 8086More details on connections and configuration options can be found with the Instream.Connection module.QueriesNote: Most queries require a database to operate on. The following places will be searched (in order from top to bottom) for a configured database:opts[:database] parameterInstream.Series struct (if used)Instream.Connection configurationNo database used!Write queries can be executed asynchronously by passing [async: true] to MyApp.MyConnection.write(). The result will then always be an immediate :ok without waiting for the query to be actually executed.By default the response of a query will be a map decoded from your server's JSON response.Alternatively you can pass [result_as: format] to MyApp.MyConnection.query/2 to change the result format to one of the following::csv CSV encoded response:json - JSON encoded response (implicit default):raw Raw server format (JSON string)Query Language SelectionIf not otherwise specified all queries will be sent as InfluxQL. This can be changed to Flux by passing the option [query_language: :flux] to MyApp.MyConnection.query/2Reading Data# passing database to query/2 MyApp.MyConnection.query( &quot;SELECT * FROM some_measurement&quot;, database: &quot;my_database&quot; ) # defining database in the query MyApp.MyConnection.query(~S( SELECT * FROM &quot;my_database&quot;.&quot;default&quot;.&quot;some_measurement&quot; )) # passing precision (= epoch) for query results MyApp.MyConnection.query( &quot;SELECT * FROM some_measurement&quot;, precision: :minutes ) # using parameter binding MyApp.MyConnection.query( &quot;SELECT * FROM some_measurement WHERE field = $field_param&quot;, params: %{field_param: &quot;some_value&quot;} )POST QueriesSome queries require you to switch from the regular read only context (all GET requets) to a write context (all POST requests).When not using the query build you have to pass that information manually to query/2:MyApp.MyConnection.query( &quot;CREATE DATABASE create_in_write_mode&quot;, method: :post )Query Timeout ConfigurationIf you find your queries running into timeouts (e.g. :hackney not waiting long enoug for a response) you can pass an option to the query call:MyApp.MyConnection.query(query, timeout: 250)This value can also be set as a default via the :recv_timeout value for your HTTP client configuration (see Instream.Connection.Config for details). A passed configuration will take precedence over the connection configuration.This does not apply to write requests. They are currently only affected by configured :recv_timeout values. Setting a connection timeout enables you to have a different timeout for read and write requests.Write queries are run through a process pool having an additional timeout:config :my_app, MyApp.MyConnection, pool_timeout: 500This configuration will be used to wait for an available worker to execute a query and defaults to 5_000.Writing PointsWriting data to your InfluxDB server can be done via Instream.Series modules or using raw maps.Please also refer to Instream.Connection.write/2 for an overview of additional options you can use when writing data.Writing Points using SeriesEach series in your database is represented by a definition module:defmodule MySeries do use Instream.Series series do database &quot;my_database&quot; measurement &quot;my_measurement&quot; tag :bar tag :foo field :value end endUsing this definition you can use the generated struct to create a data point and write it to your database:MyConnection.write(%MySeries{ fields: %MySeries.Fields{value: 17}, tags: %MySeries.Tags{bar: &quot;bar&quot;, foo: &quot;foo&quot;} })More information about series definitions can be found in the module documentation of Instream.Series.Writing Points using Plain MapsAs an alternative you can use a non-struct map to write points to a database:MyConnection.write(%{ points: [ %{ database: &quot;my_database&quot;, measurement: &quot;my_measurement&quot;, fields: %{answer: 42, value: 1}, tags: %{foo: &quot;bar&quot;}, timestamp: 1439587926000000000 }, # more points possible ... ], database: &quot;my_database&quot; })The field timestamp can be omitted, so InfluxDB will use the receive time.The field database can be used to write to a custom database.Please be aware that only the database from the first point will be used when writing multiple points.","ref":"Instream.html","title":"Instream","type":"module"},{"doc":"Defines a connection to an InfluxDB instance.Connection Definitiondefmodule MyConnection do use Instream.Connection, otp_app: :my_app endThis connection will fetch it's configuration from the application environment as defined by :otp_app. As an alternative you can define the configuration in the module definition itself:defmodule MyConnection do use Instream.Connection, config: [ host: &quot;influxdb.example.com&quot;, scheme: &quot;http&quot; ] endBoth inline and :otp_app configuration can be mixed. In this case the application configuration will overwrite any inline values.For more information on how to configure your connection please refer to the documentation of Instream.Connection.Config.Ping / Status / VersionTo validate a connection you can send ping requests to the server:MyConnection.ping()The response will be :pong on success or :error on any failure.To ping &quot;a host other than the first in your configuration&quot; you can pass it explicitly:MyConnection.ping(&quot;some.host.name&quot;)All values necessary to ping the host (scheme, port, ...) will be taken from the connection used. It does not matter whether the host is configured in that connection or not.To get InfluxDB to verify the status of your server you can send a status call:MyConnection.status() MyConnection.status(&quot;some.host.name&quot;)If you are interested in the version of InfluxDB your server is reporting you can request it:MyConnection.version() MyConnection.version(&quot;some.host.name&quot;)If the version if undetectable (no header returned) it will be reported as &quot;unknown&quot;. If the host is unreachable or an error occurred the response will be :error.","ref":"Instream.Connection.html","title":"Instream.Connection","type":"behaviour"},{"doc":"Sends a log entry to all configured loggers.","ref":"Instream.Connection.html#c:__log__/1","title":"Instream.Connection.__log__/1","type":"callback"},{"doc":"Returns a supervisable connection child_spec.","ref":"Instream.Connection.html#c:child_spec/1","title":"Instream.Connection.child_spec/1","type":"callback"},{"doc":"Returns the connection configuration.","ref":"Instream.Connection.html#c:config/1","title":"Instream.Connection.config/1","type":"callback"},{"doc":"Executes a query.","ref":"Instream.Connection.html#c:execute/2","title":"Instream.Connection.execute/2","type":"callback"},{"doc":"Pings a server.By default the first server in your connection configuration will be pinged.The server passed does not necessarily need to belong to your connection. Only the connection details (scheme, port, ...) will be used to determine the exact url to send the ping request to.","ref":"Instream.Connection.html#c:ping/2","title":"Instream.Connection.ping/2","type":"callback"},{"doc":"Executes a reading query.Options:method: whether to use a &quot;GET&quot; or &quot;POST&quot; request (as atom)precision: return data with a &quot;precision&quot; other than :rfc3339","ref":"Instream.Connection.html#c:query/2","title":"Instream.Connection.query/2","type":"callback"},{"doc":"Checks the status of a connection.","ref":"Instream.Connection.html#c:status/1","title":"Instream.Connection.status/1","type":"callback"},{"doc":"Determines the version of an InfluxDB host.The version will be retrieved using a :ping query and extract the returned X-Influxdb-Version header. If the header is missing the version will be returned as &quot;unknown&quot;.","ref":"Instream.Connection.html#c:version/2","title":"Instream.Connection.version/2","type":"callback"},{"doc":"Executes a writing query.Options:async: pass true to execute the write asynchronouslydatabase: write data to a database differing from the point databaseprecision: write points with a &quot;precision&quot; other than :nanosecondretention_policy: write data to your database with a specific retention policy, only affects writes using the line protocol (Instream.Writer.Line, default if unconfigured)","ref":"Instream.Connection.html#c:write/2","title":"Instream.Connection.write/2","type":"callback"},{"doc":"","ref":"Instream.Connection.html#t:log_entry/0","title":"Instream.Connection.log_entry/0","type":"type"},{"doc":"","ref":"Instream.Connection.html#t:precision/0","title":"Instream.Connection.precision/0","type":"type"},{"doc":"","ref":"Instream.Connection.html#t:query_type/0","title":"Instream.Connection.query_type/0","type":"type"},{"doc":"Configuration helper module.How To ConfigureStatic ConfigurationOne way to configure your connection is using the application environment:config :my_app, MyConnection, database: &quot;my_default_database&quot;, host: &quot;localhost&quot;, port: 8086Please be aware that if you are using the scheme &quot;http+unix&quot; you need to encode the socket path yourself:config :my_app, MyConnection, host: URI.encode_www_form(&quot;/path/to/influxdb.sock&quot;)Dynamic ConfigurationIf you cannot, for whatever reason, use a static application config you can configure an initializer module that will be called every time your connection is started (or restarted) in your supervision tree:config :my_app, MyConnection, init: {MyInitModule, :my_init_fun} defmodule MyInitModule do @spec my_init_fun(module) :: :ok def my_init_fun(conn) do config = Keyword.merge( conn.config(), host: &quot;localhost&quot;, port: 64210 ) Application.put_env(:my_app, conn, config) end endWhen the connection is started the function will be called with the connection module as the first (and only) parameter. This will be done before the connection is available for use.The function is expected to always return :ok.Inline ConfigurationFor some use cases (e.g. testing) it may be sufficient to define hardcoded configuration defaults outside of your application environment:defmodule MyConnection do use Instream.Connection, otp_app: :my_app, config: [ host: &quot;localhost&quot;, port: 8086 ] endThese values will be overwritten by and/or merged with the application environment values when the configuration is accessed.Runtime and Compile Time ConfigurationThe full connection configuration is split into two parts, compile time and runtime configuration.Compile time configuration values are, as the name implies, used during compilation for the connection module. Currently the only key in this category is :loggers.All other values are directly accessed from the application environment using Application.get_env(connection_otp_app, connection_module) and therefore can be changed without recompilation:old_config = MyConnection.config() new_config = Keyword.put(old_config, :host, &quot;changed.host&quot;) :ok = Application.put_env(:my_app, MyConnection, new_config)Configuration DefaultsThe following values will be used as defaults if no other value is set:config :my_app, MyConnection, host: &quot;localhost&quot;, pool: [max_overflow: 10, size: 5], port: 8086, scheme: &quot;http&quot;, writer: Instream.Writer.Line, json_decoder: {Jason, :decode!, [[keys: :atoms]]}, json_encoder: {Jason, :encode!, []}This also means that per default the connection uses no authentication.HTTP Client ConfigurationInternally all requests are done using :hackney.The configuration key :http_opts is directly passed to the client process. Parts of it are also used internally by :hackney to control more generic behaviour (request pool to be used and it's configuration).Please see :hackney.request/5 for a complete list of available options.Setting the :http_opts key when calling a connection method allows usage of per-call options. The options are merged with the connection options and then passed on.JSON ConfigurationBy default the library used for encoding/decoding JSON is :jason. For the time :instream directly depends on it to ensure it is available.If you want to use another library you can switch it:config :my_app, MyConnection, json_decoder: MyJSONLibrary, json_encoder: MyJSONLibrary config :my_app, MyConnection, json_decoder: {MyJSONLibrary, :decode_argless}, json_encoder: {MyJSONLibrary, :decode_argless} config :my_app, MyConnection, json_decoder: {MyJSONLibrary, :decode_it, [[keys: :atoms]]}, json_encoder: {MyJSONLibrary, :decode_it, []}If you configure only a module name it will be called as module.decode!(binary) and module.encode!(map). When using a more complete {m, f} or {m, f, a} configuration the data to decode/encode will passed as the first argument with your configured extra arguments following.AuthenticationTo connect to an InfluxDB instance with http authentication enabled you have to configure your credentials:config :my_app, MyConnection, auth: [method: :basic, username: &quot;root&quot;, password: &quot;root&quot;]For method you can choose between header authentication (basic auth) using :basic or query parameters using :query. If nothing or an invalid value is given the connection will be made using :basic authentication.Writer ConfigurationIf you are using the regular line protocol writer Instream.Writer.Line you are done without having anything to configure. It is used by default and connects to the port you have configured for connection.To write points over UDP you can adjust your configuration:config :my_app, MyConnection, host: &quot;localhost&quot;, port_udp: 8089, writer: Instream.Writer.UDPThe connection will then write using UDP and connecting to the port :port_udp. All non-write queries will be send to the regular :port you have configured.LoggingAll queries are (by default) logged using Logger.debug/1 via the default logging module Instream.Log.DefaultLogger. To customize logging you have to alter the configuration of your connection:config :my_app, MyConnection, loggers: [ {FirstLogger, :log_fun, []}, {SecondLogger, :log_fun, [:additional, :args]} ]This configuration replaces the default logging module.Configuration is given as a tuple of {module, function, arguments}. The log entry will be inserted as the first argument of the method call. It will be one of Instream.Log.PingEntry, Instream.Log.QueryEntry, Instream.Log.StatusEntry or Instream.Log.WriteEntry, depending on what type of request should be logged.Please be aware that every logger has to return the entry it received in order to allow combining multiple loggers.In addition to query specific information every entry carries metadata around::query_time: milliseconds it took to send request and receive the response:response_status: status code or 0 if not applicable/availableWhen using the default logger you have to re-configure :logger to be able to get them printed:config :logger, :console, format: &quot;$time $metadata[$level] $levelpad$message &quot;, metadata: [:application, :pid, :query_time, :response_status]To prevent a query from logging you can pass an option:MyConnection.ping(log: false) MyConnection.query(query, log: false)","ref":"Instream.Connection.Config.html","title":"Instream.Connection.Config","type":"module"},{"doc":"Retrieves the compile time part of the connection configuration.","ref":"Instream.Connection.Config.html#compile_time/3","title":"Instream.Connection.Config.compile_time/3","type":"function"},{"doc":"Retrieves the runtime connection configuration for conn in otp_app.","ref":"Instream.Connection.Config.html#runtime/4","title":"Instream.Connection.Config.runtime/4","type":"function"},{"doc":"Defines a database.Usagedefmodule MyDatabase do use Instream.Database database do name &quot;my_database&quot; end endMetadataThe metadata of a database (e.g. the name) can be retrieved using the __meta__/1 method.","ref":"Instream.Database.html","title":"Instream.Database","type":"behaviour"},{"doc":"Provides metadata access for a database.Available information:name - the name of the database","ref":"Instream.Database.html#c:__meta__/1","title":"Instream.Database.__meta__/1","type":"callback"},{"doc":"Defines the database.","ref":"Instream.Database.html#database/1","title":"Instream.Database.database/1","type":"macro"},{"doc":"Defines the name of the database.","ref":"Instream.Database.html#name/1","title":"Instream.Database.name/1","type":"macro"},{"doc":"Default logger for all entries.","ref":"Instream.Log.DefaultLogger.html","title":"Instream.Log.DefaultLogger","type":"module"},{"doc":"Logs a request.","ref":"Instream.Log.DefaultLogger.html#log/1","title":"Instream.Log.DefaultLogger.log/1","type":"function"},{"doc":"Metadata common to all log entries.","ref":"Instream.Log.Metadata.html","title":"Instream.Log.Metadata","type":"module"},{"doc":"","ref":"Instream.Log.Metadata.html#t:t/0","title":"Instream.Log.Metadata.t/0","type":"type"},{"doc":"Log entry definition for ping requests.","ref":"Instream.Log.PingEntry.html","title":"Instream.Log.PingEntry","type":"module"},{"doc":"","ref":"Instream.Log.PingEntry.html#t:t/0","title":"Instream.Log.PingEntry.t/0","type":"type"},{"doc":"Log entry definition for query requests.","ref":"Instream.Log.QueryEntry.html","title":"Instream.Log.QueryEntry","type":"module"},{"doc":"","ref":"Instream.Log.QueryEntry.html#t:t/0","title":"Instream.Log.QueryEntry.t/0","type":"type"},{"doc":"Log entry definition for status requests.","ref":"Instream.Log.StatusEntry.html","title":"Instream.Log.StatusEntry","type":"module"},{"doc":"","ref":"Instream.Log.StatusEntry.html#t:t/0","title":"Instream.Log.StatusEntry.t/0","type":"type"},{"doc":"Log entry definition for write requests.","ref":"Instream.Log.WriteEntry.html","title":"Instream.Log.WriteEntry","type":"module"},{"doc":"","ref":"Instream.Log.WriteEntry.html#t:t/0","title":"Instream.Log.WriteEntry.t/0","type":"type"},{"doc":"Query struct.","ref":"Instream.Query.html","title":"Instream.Query","type":"module"},{"doc":"","ref":"Instream.Query.html#t:payload_type/0","title":"Instream.Query.payload_type/0","type":"type"},{"doc":"","ref":"Instream.Query.html#t:query_method/0","title":"Instream.Query.query_method/0","type":"type"},{"doc":"","ref":"Instream.Query.html#t:query_type/0","title":"Instream.Query.query_type/0","type":"type"},{"doc":"","ref":"Instream.Query.html#t:t/0","title":"Instream.Query.t/0","type":"type"},{"doc":"Response parser.","ref":"Instream.Response.html","title":"Instream.Response","type":"module"},{"doc":"Maybe parses a response based on the requested result type.","ref":"Instream.Response.html#maybe_parse/2","title":"Instream.Response.maybe_parse/2","type":"function"},{"doc":"Parses the response of a ping query.","ref":"Instream.Response.html#parse_ping/1","title":"Instream.Response.parse_ping/1","type":"function"},{"doc":"Parses the response of a status query.","ref":"Instream.Response.html#parse_status/1","title":"Instream.Response.parse_status/1","type":"function"},{"doc":"Parses the response of a version query.Returns &quot;unknown&quot; if the response did not contain a parseable header.","ref":"Instream.Response.html#parse_version/1","title":"Instream.Response.parse_version/1","type":"function"},{"doc":"","ref":"Instream.Response.html#t:t/0","title":"Instream.Response.t/0","type":"type"},{"doc":"Defines a series.Series DefinitionIf you do not want to define the raw maps for writing data you can pre-define a series module for later usage:defmodule MySeries do use Instream.Series series do database &quot;my_database_optional&quot; measurement &quot;cpu_load&quot; tag :host, default: &quot;www&quot; tag :core field :value, default: 100 field :value_desc end endThe macros tag/2 and field/2 both accept a keyword tuple with a :default entry. This value will be pre-assigned when using the data struct with all other fields or tags being set to nil.MetadataThe metadata of a series (e.g. the measurement) can be retrieved using the __meta__/1 method.StructEvery series will be registered as a struct. Following the above usage example you will get the following struct:%MySeries{ fields: %MySeries.Fields{value: 100, value_desc: nil}, tags: %MySeries.Tags{host: &quot;www&quot;, core: nil}, timestamp: nil }:timestamp is expected to be a unix nanosecond timestamp.Series HydrationWhenever you want to convert a plain map or a query result into a specific series you can use the built-in hydration methods:MySeries.from_map(%{ timestamp: 1234567890, some_tag: &quot;hydrate&quot;, some_field: 123 }) ~S(&quot;SELECT * FROM &quot;my_measurement&quot;) |&gt; MyConnection.query() |&gt; MySeries.from_result()The timestamp itself is kept &quot;as is&quot; for integer values, timestamps in RFC3339 format (e.g. &quot;1970-01-01T01:00:00.000+01:00&quot;) will be converted to :nanosecond integer values.Please be aware that when using an OTP release prior to 21.0 the time will be truncated to :microsecond precision due to :calendar.rfc3339_to_system_time/2 not being available and DateTime.from_iso8601/1 only supporting microseconds.Writing Series PointsYou can then use your series module to assemble a data point (one at a time) for writing:data = %MySeries{} data = %{data | fields: %{data.fields | value: 17}} data = %{data | tags: %{data.tags | bar: &quot;bar&quot;, foo: &quot;foo&quot;}}And then write one or many at once:MyConnection.write(point) MyConnection.write([point_1, point_2, point_3])If you want to pass an explicit timestamp to the database you can use the key :timestamp:data = %MySeries{} data = %{data | timestamp: 1439587926000000000}The timestamp is (by default) expected to be a nanosecond unix timestamp. To use different precision (for all points in this write operation!) you can change this value by modifying your write call:data = %MySeries{} data = %{data | timestamp: 1439587926} MyConnection.write(data, precision: :second)Supported precision types are::hour:minute:second:millisecond:microsecond:nanosecondPlease be aware that the UDP protocol writer does not support custom timestamp precisions. All UDP timestamps are implicitly expected to already be at nanosecond precision.Note: While it is possible to write multiple points a once it is currently not supported to write them to individual databases. The first point written defines the database, other values are silently ignored!","ref":"Instream.Series.html","title":"Instream.Series","type":"behaviour"},{"doc":"Provides metadata access for a series.Available information:database - the database where the series is stored (optional):fields - the fields in the series:measurement - the measurement of the series:tags - the available tags defining the series","ref":"Instream.Series.html#c:__meta__/1","title":"Instream.Series.__meta__/1","type":"callback"},{"doc":"Defines the database for the series.","ref":"Instream.Series.html#database/1","title":"Instream.Series.database/1","type":"macro"},{"doc":"Defines a field in the series.","ref":"Instream.Series.html#field/2","title":"Instream.Series.field/2","type":"macro"},{"doc":"Creates a series dataset from any given map.Keys not defined in the series are silently dropped.","ref":"Instream.Series.html#c:from_map/1","title":"Instream.Series.from_map/1","type":"callback"},{"doc":"Creates a list of series datasets from a query result map.Keys not defined in the series are silently dropped.","ref":"Instream.Series.html#c:from_result/1","title":"Instream.Series.from_result/1","type":"callback"},{"doc":"Defines the measurement of the series.","ref":"Instream.Series.html#measurement/1","title":"Instream.Series.measurement/1","type":"macro"},{"doc":"Defines the series.","ref":"Instream.Series.html#series/1","title":"Instream.Series.series/1","type":"macro"},{"doc":"Defines a tag in the series.","ref":"Instream.Series.html#tag/2","title":"Instream.Series.tag/2","type":"macro"},{"doc":"Point writer behaviour.","ref":"Instream.Writer.html","title":"Instream.Writer","type":"behaviour"},{"doc":"Called during worker initialization.This will be called for every process in the worker pool individually.","ref":"Instream.Writer.html#c:init_worker/1","title":"Instream.Writer.init_worker/1","type":"callback"},{"doc":"Called during worker termination.This will be called for every process in the worker pool individually.","ref":"Instream.Writer.html#c:terminate_worker/1","title":"Instream.Writer.terminate_worker/1","type":"callback"},{"doc":"Writes a point.","ref":"Instream.Writer.html#c:write/3","title":"Instream.Writer.write/3","type":"callback"},{"doc":"","ref":"Instream.Writer.html#t:worker_state/0","title":"Instream.Writer.worker_state/0","type":"type"},{"doc":"Point writer for the line protocol.","ref":"Instream.Writer.Line.html","title":"Instream.Writer.Line","type":"module"},{"doc":"Callback implementation for Instream.Writer.write/3.","ref":"Instream.Writer.Line.html#write/3","title":"Instream.Writer.Line.write/3","type":"function"},{"doc":"Point writer for the line protocol using UDP.","ref":"Instream.Writer.UDP.html","title":"Instream.Writer.UDP","type":"module"},{"doc":"Callback implementation for Instream.Writer.init_worker/1.","ref":"Instream.Writer.UDP.html#init_worker/1","title":"Instream.Writer.UDP.init_worker/1","type":"function"},{"doc":"Callback implementation for Instream.Writer.terminate_worker/1.","ref":"Instream.Writer.UDP.html#terminate_worker/1","title":"Instream.Writer.UDP.terminate_worker/1","type":"function"},{"doc":"Callback implementation for Instream.Writer.write/3.","ref":"Instream.Writer.UDP.html#write/3","title":"Instream.Writer.UDP.write/3","type":"function"}]